/******************************************************************************
 // Synopsis:
 //-----------------------
 // Dependencies:
 //
 //-----------------------
 // CVS:
 // $Author: ruschi $
 // $Date: 2004/11/14 19:15:19 $
 // $Revision: 1.4 $ 
 //-----------------------------------------------------------------------------
 //  Copyright (C) 2004 by Thomas Ruschival                               
 //  ruschi@doomgarage.de                                                 
 //                                                                       
 //  This program is free software; you can redistribute it and/or modify 
 //  it under the terms of the GNU General Public License as published by 
 //  the Free Software Foundation; either version 2 of the License, or    
 //  (at your option) any later version.                                  
 //                                                                       
 //  This program is distributed in the hope that it will be useful,      
 //  but WITHOUT ANY WARRANTY; without even the implied warranty of       
 //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 //  GNU General Public License for more details.                         
 //                                                                       
 //  You should have received a copy of the GNU General Public License    
 //  along with this program; if not, write to the                        
 //  Free Software Foundation, Inc.,                                      
 //  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            
 *******************************************************************************/
#include "cdinfo.h"

using namespace std;

 
/**
 * Methods
 */
/**
 * Get the value of title
 * name of this CD
 * @return the value of title
 */
string CDInfo::get_title ( ) {
	return title;
}
/**
 * Set the value of title
 * name of this CD
 * @param value the value of title
 */
void CDInfo::set_title (string value ) {
	title = value;
}
/**
 * Get the value of subtitle
 * additional information for the title will be shown in a smaller font
 * @return the value of subtitle
 */
string CDInfo::get_subtitle ( ) {
	return subtitle;
}
/**
 * Set the value of subtitle
 * additional information for the title will be shown in a smaller font
 * @param value the value of subtitle
 */
void CDInfo::set_subtitle (string value ) {
	subtitle = value;
}
/**
 * Get the value of artist
 * Original singer/band that published this album - leave it fro sampler
 * @return the value of artist
 */
string CDInfo::get_artist ( ) {
	return artist;
}
/**
 * Set the value of artist
 * Original singer/band that published this album - leave it fro sampler
 * @param value the value of artist
 */
void CDInfo::set_artist (string value ) {
	artist = value;
}
/**
 * Get the value of setnumber
 * Edition, volume (if this is a multi-CD Compilation)
 * @return the value of setnumber
 */
int CDInfo::get_setnumber ( ) {
	return setnumber;
}
/**
 * Set the value of setnumber
 * Edition, volume (if this is a multi-CD Compilation)
 * @param value the value of setnumber
 */
void CDInfo::set_setnumber (int value ) {
	setnumber = value;
}
/**
 * Get the value of tracks
 * container for all tracks
 * @return the value of tracks
 */
vector<TrackInfo> CDInfo::get_tracks ( ) {
	return tracks;
}
/**
 * Set the value of tracks
 * container for all tracks
 * @param value the value of tracks
 */
void CDInfo::set_tracks (vector<TrackInfo> value ) {
	tracks=value;
}
/**
 * Get the value of composer
 * Composer / publisher  of the CD (mostly who ripped this thing)
 * @return the value of composer
 */
string CDInfo::get_composer ( ) {
	return composer;
}
/**
 * Set the value of composer
 * Composer / publisher  of the CD (mostly who ripped this thing)
 * @param value the value of composer
 */
void CDInfo::set_composer (string value ) {
	composer=value;
}
/**
 * Get the value of publishdate
 * Date CD was published
 * @return the value of publishdate
 */
string CDInfo::get_publishdate ( ) {
	return publishdate;
}
/**
 * Set the value of publishdate
 * Date CD was published
 * @param value the value of publishdate
 */
void CDInfo::set_publishdate (string value ) {
	publishdate=value;
}
/**
 * appends the new track to tracklist
 */
void CDInfo::addTrack (TrackInfo newtrack) {
	tracks.push_back(newtrack);
	vector<TrackInfo>::iterator it = tracks.end();
	it-=1;
//	cout << " Track added : " << (*it).get_number() << " " << (*it).get_title() << endl;

}
/**
 * add the new track to tracklist at position index throws exception if no such position
 */
void CDInfo::addTrackAt (int index, TrackInfo &newTrack) {
	vector<TrackInfo>::iterator it = tracks.begin();
	it+=(index-1);
	tracks.insert(it,newTrack);
}
/**
 * delete a track from tracklist
 */
void CDInfo::deleteTrack (int index) {
	vector<TrackInfo>::iterator it = tracks.begin();
	it+=(index-1);
	tracks.erase(it);
}
/**
 * 
 */
void CDInfo::deleteTrack (TrackInfo &track) {
	cout<< "ERROR: CDInfo.deleteTrack(TrackInfo) not implemented!\n";
}

