/******************************************************************************
* Synopsis:
*-----------------------
* Dependencies:
*
*-----------------------
* CVS:
* $Author: ruschi $
* $Date: 2004/11/11 21:11:20 $
* $Revision: 1.1.1.1 $ 
*-----------------------------------------------------------------------------
*  Copyright (C) 2004 by Thomas Ruschival                               
*  ruschi@doomgarage.de                                                 
*                                                                       
*  This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by 
*  the Free Software Foundation; either version 2 of the License, or    
*  (at your option) any later version.                                  
*                                                                       
*  This program is distributed in the hope that it will be useful,      
*  but WITHOUT ANY WARRANTY; without even the implied warranty of       
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
*  GNU General Public License for more details.                         
*                                                                       
*  You should have received a copy of the GNU General Public License    
*  along with this program; if not, write to the                        
*  Free Software Foundation, Inc.,                                      
*  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            
*******************************************************************************/
#ifndef CDINFOREADER_CDROM_H
#define CDINFOREADER_CDROM_H

#include <string>
#include <vector>

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <fcntl.h>
#include <unistd.h>

#include <sys/ioctl.h>
#include <sys/types.h>
#include <linux/cdrom.h>

#include "clientsocket.h"
#include "cdinforeader.h"
#include "cdinlay_util.h"
#include "socketexception.h"

using namespace std;

class CDInfoReader_cdrom : public CDInfoReader{
 
  /**
   * Public stuff
   */
 	
 public:
  CDInfoReader_cdrom(string infile);
  CDInfoReader_cdrom();
  ~CDInfoReader_cdrom(){};

  /**
   * parse the file, split the lines, generate trackinfos
   */
  void readCDInfo (CDInfo &content);

  /**
   * look up the contents in CDDB
   */
  void lookup();
  
  /**
   * read all raw information form CDROM
   */
  int calcDiscID();

  /**
  * Calculate the CDDB fromat
  */
  unsigned long cddbDiscID(int tot_trks);
  unsigned int  cddbSum(int n);
  int readTOC();
	
  /**
   * find out if the reader is suitable for the
   * source
   * @param infile string filename
   * @return fits int 0 if false, 1 if it fits
   */
  int matches(string infile);



 private:
  string discid_query;
  unsigned long discid;
  int tracks;
  struct toc {
	int min, sec, frame;
  } cdtoc[100];
  string content;		
	
};
#endif
