/******************************************************************************
// Synopsis:
//-----------------------
// Dependencies:
//
//-----------------------
// CVS:
// $Author: ruschi $
// $Date: 2004/11/21 17:01:37 $
// $Revision: 1.6 $ 
//-----------------------------------------------------------------------------
//  Copyright (C) 2004 by Thomas Ruschival                               
//  ruschi@doomgarage.de                                                 
//                                                                       
//  This program is free software; you can redistribute it and/or modify 
//  it under the terms of the GNU General Public License as published by 
//  the Free Software Foundation; either version 2 of the License, or    
//  (at your option) any later version.                                  
//                                                                       
//  This program is distributed in the hope that it will be useful,      
//  but WITHOUT ANY WARRANTY; without even the implied warranty of       
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
//  GNU General Public License for more details.                         
//                                                                       
//  You should have received a copy of the GNU General Public License    
//  along with this program; if not, write to the                        
//  Free Software Foundation, Inc.,                                      
//  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            
*******************************************************************************/

#ifndef CDINFOREADER_CSV_H
#define CDINFOREADER_CSV_H

#include <string>
#include <vector>

#include <iostream>
#include <cstdlib>
#include <fstream>
#include <algorithm>	// used for filename UPPERCASE
#include <cctype>		// Conversion

#include "cdinforeader.h"

using namespace std;
/**
 * Class CDInfoReader_csv
 * CSV parser for trackinfo files
 * Track infos are taken in this order:
 * artist ; album ; song title; genre; release date;time;comment
 */
class CDInfoReader_csv : public CDInfoReader {
/**
 * Public stuff
 */
public:
	/**
 	* parse the file, split the lines, generate trackinfos
	*/
	void readCDInfo (CDInfo &content);

	/**
	 * find out if the reader is suitable for the
	 * source
	 * @param infile string filename
	 * @return fits int 0 if false, 1 if it fits
	 */
	int matches(string infile);
	
	/**
	 * Get the value of delimiter
	 * character that separates the fields in the file
	 * @return the value of delimiter
	 */
	 string get_delimiter ( );
		
	
	/**
	 * Set the value of delimiter
	 * character that separates the fields in the file
	 * @param value the value of delimiter
	 */
	void set_delimiter (string value );

	/**
	 * split the lines into usable tokens
	 */
	void  tokenize (const string& line, vector<string>& schnipsel);

	/**
	 * Empty Constructor
	 */
	CDInfoReader_csv(string infile);
	CDInfoReader_csv();
		

/**
 * Private stuff
 */
private:
 	/**
	 * Fields
	 */
	/**
 	* delimiter
	 */
	string delimiter;
};




#endif //CDINFOREADER_CSV_H

