/******************************************************************************
 // Synopsis:
 //-----------------------
 // Dependencies:
 //
 //-----------------------
 // CVS:
 // $Author: ruschi $
 // $Date: 2004/11/21 17:01:37 $
 // $Revision: 1.2 $ 
 //-----------------------------------------------------------------------------
 //  Copyright (C) 2004 by Thomas Ruschival                               
 //  ruschi@doomgarage.de                                                 
 //                                                                       
 //  This program is free software; you can redistribute it and/or modify 
 //  it under the terms of the GNU General Public License as published by 
 //  the Free Software Foundation; either version 2 of the License, or    
 //  (at your option) any later version.                                  
 //                                                                       
 //  This program is distributed in the hope that it will be useful,      
 //  but WITHOUT ANY WARRANTY; without even the implied warranty of       
 //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 //  GNU General Public License for more details.                         
 //                                                                       
 //  You should have received a copy of the GNU General Public License    
 //  along with this program; if not, write to the                        
 //  Free Software Foundation, Inc.,                                      
 //  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            
 *******************************************************************************/


#include "cdinforeader_other.h"

using namespace std;


CDInfoReader_other::CDInfoReader_other(string infile):CDInfoReader(infile){
	name = "Other Parser";
	filetype = "oth";

	description="!! Other Parser just as an example !!\n";
	description+="does nothing at all\n";
	description+="Version: $Revision: 1.2 $ Copyright (c) 2004 Thomas Ruschival \n";
}


CDInfoReader_other::CDInfoReader_other():CDInfoReader(){
	name = "Other Parser";
	filetype = "oth";

	description="!! Other Parser just as an example !!\n";
	description+="does nothing at all\n";
	description+="Version: $Revision: 1.2 $ Copyright (c) 2004 Thomas Ruschival \n";
}



/**
 * find out if the reader is suitable for the
 * source
 * @param infile string filename
 * @return fits int 0 if false, 1 if it fits
 */
int  CDInfoReader_other::matches(string infile){
	// find and extract the extension of the file
	int pos = infile.find_last_of('.',infile.size());
	string extension = infile.substr(pos+1,infile.size());
	// Make the fileextension lowercase
	std::transform(extension.begin(),extension.end(),extension.begin(),(int(*)(int)) tolower);
	//Get information about file; determine by extension
	if(extension == filetype){
		return 1;
	}
	else{
		return 0;
	}
}

/**
 * parse the file, split the lines, generate trackinfos
 */
void CDInfoReader_other::readCDInfo (CDInfo &content) {
	cout << name << " reads CDinformation "<< endl;
}



/**
 * Constructors/Destructors
 */
extern "C" CDInfoReader* create(string infile){
	return new CDInfoReader_other(infile);
	//return new CDInfoReader_other;
}

extern "C" void destroy(CDInfoReader* todestroy){
	delete todestroy;
}

