/******************************************************************************
 // Synopsis:
 //-----------------------
 // Dependencies:
 //
 //-----------------------
 // CVS:
 // $Author: ruschi $
 // $Date: 2004/11/21 17:01:38 $
 // $Revision: 1.7 $ 
 //-----------------------------------------------------------------------------
 //  Copyright (C) 2004 by Thomas Ruschival                               
 //  ruschi@doomgarage.de                                                 
 //                                                                       
 //  This program is free software; you can redistribute it and/or modify 
 //  it under the terms of the GNU General Public License as published by 
 //  the Free Software Foundation; either version 2 of the License, or    
 //  (at your option) any later version.                                  
 //                                                                       
 //  This program is distributed in the hope that it will be useful,      
 //  but WITHOUT ANY WARRANTY; without even the implied warranty of       
 //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 //  GNU General Public License for more details.                         
 //                                                                       
 //  You should have received a copy of the GNU General Public License    
 //  along with this program; if not, write to the                        
 //  Free Software Foundation, Inc.,                                      
 //  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            
 *******************************************************************************/

#include <getopt.h>
#include <cstdlib>
#include <iostream>
#include "cdinfo.h"
#include "cdcover.h"
#include "cdinforeader.h"
#include "cdinfofactory.h"

using namespace std;

/**
 * some variables just used by old getopt
 */


/**
 * well, the usual main function to start with
 */
int main(int argc, char** argv){
	int opt;				// tempvariable to gop through the option array
	int option_index = 0;

	string infile;			// File to read information from
	string outfile;			// name of the PDF to write
	// Container to store infomation we got from commandline parameters
	CDInfo geninfo;
	// struct for possible options -> getopt.h
	static struct option long_options[] = {
		{"title", 1, 0, 't'},				// title of this CD
		{"subtitle", 1, 0, 's'},			// Subtitle
		{"artist", 1, 0, 'a'},				// Artist of the CD
		{"setno", 1, 0, 'n'},				// volume id if this is a multiCDCompilation
		{"composer", 1, 0, 'c'},			// Who pirated this CD
		{"infile", 1, 0, 'i'},				// File to read trackinfo from
		{"outfile", 1, 0, 'o'},				// name of the PDF
		{"help",0,0,'?'},					// help the poor fellows
		{0, 0, 0, 0}						// According to the Docu  -> "The last element of the array has to be filled with zeroes. "
	};


	/* Run through all available options */
	while ((opt = getopt_long (argc, argv, "t:s:a:n:c:i:o:?",long_options, &option_index))!= -1) {
		switch( opt ){
				case 't':
					geninfo.set_title(optarg);
					break;
				case 'a':
					geninfo.set_artist(optarg);
					break;
				case 'i':
					infile = optarg;
					break;
				case 'o':
					outfile = optarg;
					break;
				case 'c':
					geninfo.set_composer(optarg);
					break;
				case 's':
					geninfo.set_subtitle(optarg);
					break;
				case 'n':
					geninfo.set_setnumber(1);
					break;
				case '?':
					cout << "Usage: cdinlay -i infile -o outfile [-t title] [-s subtitle] [-a artist] "<< endl;
					cout << "			[-n setnumber] [-c composer] [-s]"<< endl;
					cout << "\noptional Arguments:\n";
					cout << "-t --title foo			: title of cd  "<< endl;
					cout << "-s --subtitle bar		: subtitle of cd  "<< endl;
					cout << "-a --artist dumbo		: title of cd  "<< endl;
					cout << "-n --setno o			: volume (if this is a multi cd-compilation)"<< endl;
					cout << "-c --composer leechuck		: who pirated the track on this CD  "<< endl;
					break;
		}
	}
	CDCover cover(geninfo,infile,outfile);
	cover.generate();
	return EXIT_SUCCESS;
}

