#include "socketexception.h"

using std::string;
/**
 * Constructors/Destructors
 */
/**
 * Methods
 */
/**
 * Get the value of message
 * String telling the user what happened, general explanation of Exception
 * @return the value of message
 */
string SocketException::get_message ( ) {
	return message;
}
/**
 * Set the value of message
 * String telling the user what happened, general explanation of Exception
 * @param value the value of message
 */
void SocketException::set_message (string value ) {
	message = value;
}
/**
 * Get the value of errcode
 * integer representation of this exception, so it can be easier handled by catch blocks default to -1
 * @return the value of errcode
 */
int SocketException::get_errcode ( ) {
	return errcode;
}
/**
 * Set the value of errcode
 * integer representation of this exception, so it can be easier handled by catch blocks default to -1
 * @param value the value of errcode
 */
void SocketException::set_errcode (int value ) {
	errcode = value;
}
/**
 * Constructor with message cause and errcode set
 */
SocketException::SocketException (string message, string cause, int errcode) {
	 this->message 	= message;
	 this->cause 	= cause;
	 this->errcode 	= errcode;
}
/**
 * Get the value of cause
 * Where and why did this message occur
 * @return the value of cause
 */
string SocketException::get_cause ( ) {
	return cause;
}
/**
 * Set the value of cause
 * Where and why did this message occur
 * @param value the value of cause
 */
void SocketException::set_cause (string value ) {
	cause = value;
}
/**
 * Simpler constructor if you don't want to use the errorcodes
 */
SocketException::SocketException (string message, string cause) {
	this->message 	= message;
	this->cause 	= cause;
	this->errcode	= -1;
}

