#ifndef SOCKETEXCEPTION_H
#define SOCKETEXCEPTION_H
#include <string>


using std::string;

/**
 * Class SocketException
 * General Exception that can occour while dealing with sockets
 */
class SocketException {
/**
 * Public stuff
 */
public:
	SocketException ( ) { }

	/**
	 * Constructor with message cause and errcode set
	 */
	  SocketException (string message, string cause, int errcode);
		
	
	/**
	 * Simpler constructor if you don't want to use the errorcodes
	 */
	SocketException (string message, string cause);
		/**
	 * Accessor Methods
		 */
	/**
	 * Get the value of message
	 * String telling the user what happened, general explanation of Exception
	 * @return the value of message
	 */
	string get_message ( );
		
	
	/**
	 * Set the value of message
	 * String telling the user what happened, general explanation of Exception
	 * @param value the value of message
	 */
	void set_message (string value );
		
	
	/**
	 * Get the value of errcode
	 * integer representation of this exception, so it can be easier handled by catch blocks default to -1
	 * @return the value of errcode
	 */
	int get_errcode ( );
		
	
	/**
	 * Set the value of errcode
	 * integer representation of this exception, so it can be easier handled by catch blocks default to -1
	 * @param value the value of errcode
	 */
	void set_errcode (int value );
		
	
	/**
	 * Get the value of cause
	 * Where and why did this message occur
	 * @return the value of cause
	 */
	string get_cause ( );
		

	/**
	 * Set the value of cause
	 * Where and why did this message occur
	 * @param value the value of cause
	 */
	void set_cause (string value );
		
/**
 * Private stuff
 */
private:
	/**
	 * Fields
	 */
	/**
	 * String telling the user what happened, general explanation of Exception
	 */
	 string message;
	/**
	 * integer representation of this exception, so it can be easier handled by catch blocks default to -1
	 */
	 int errcode;
	/**
	 * Where and why did this message occur
	 */
	 string cause;


	
	/**
	 * Operations
	 */
};

#endif //SOCKETEXCEPTION_H

