/******************************************************************************
 // Synopsis:
 //-----------------------
 // Dependencies:
 //
 //-----------------------
 // CVS:
 // $Author: ruschi $
 // $Date: 2004/11/16 10:17:07 $
 // $Revision: 1.4 $ 
 //-----------------------------------------------------------------------------
 //  Copyright (C) 2004 by Thomas Ruschival                               
 //  ruschi@doomgarage.de                                                 
 //                                                                       
 //  This program is free software; you can redistribute it and/or modify 
 //  it under the terms of the GNU General Public License as published by 
 //  the Free Software Foundation; either version 2 of the License, or    
 //  (at your option) any later version.                                  
 //                                                                       
 //  This program is distributed in the hope that it will be useful,      
 //  but WITHOUT ANY WARRANTY; without even the implied warranty of       
 //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 //  GNU General Public License for more details.                         
 //                                                                       
 //  You should have received a copy of the GNU General Public License    
 //  along with this program; if not, write to the                        
 //  Free Software Foundation, Inc.,                                      
 //  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            
 *******************************************************************************/

#ifndef TRACKINFO_H
#define TRACKINFO_H
#include <string>
#include <iostream>

using namespace std;
/**
 * Class TrackInfo
 * Containing all meta information about the track will be read form MP3 idv3 tags, ASCII..... and much more,
 * CDInfoReader extracts this information from whatever.
 */
class TrackInfo {
	/**
	 * Public stuff
	 */
 public:
	/**
	 * Constructors
	 */
	/**
	 * Empty Constructor
	 */
	TrackInfo ( ) { }

	/**
	 * Accessor Methods
	 */
	/**
	 * Get the value of number
	 * number of the track on original album
	 * @return the value of number
	 */
	int get_number ( );
		
	
	/**
	 * Set the value of number
	 * number of the track on original album
	 * @param value the value of number
	 */
	void set_number (int value );
		
	
	/**
	 * Get the value of title
	 * Title of track
	 * @return the value of title
	 */
	string get_title ( );
		
	
	/**
	 * Set the value of title
	 * Title of track
	 * @param value the value of title
	 */
	void set_title (string value );
		
	
	/**
	 * Get the value of artist
	 * Singer/Composer of this track
	 * @return the value of artist
	 */
	string get_artist ( );
		
	
	/**
	 * Set the value of artist
	 * Singer/Composer of this track
	 * @param value the value of artist
	 */
	void set_artist (string value );
		
	
	/**
	 * Get the value of albumtitle
	 * title of the album this track was published
	 * @return the value of albumtitle
	 */
	string get_albumtitle ( );
		
	
	/**
	 * Set the value of albumtitle
	 * title of the album this track was published
	 * @param value the value of albumtitle
	 */
	void set_albumtitle (string value );
		
	
	/**
	 * Get the value of time
	 * length of the track
	 * @return the value of time
	 */
	int get_time ( );
		
	
	/**
	 * Set the value of time
	 * length of the track
	 * @param value the value of time
	 */
	void set_time (int value );
		
	
	/**
	 * Get the value of genre
	 * always incorrect information set in ID3v2 tags of an mp3, its implemented just in case
	 * sb wants to have this information
	 * @return the value of genre
	 */
	string get_genre ( );
		
	
	/**
	 * Set the value of genre
	 * always incorrect information set in ID3v2 tags of an mp3, its implemented just in case 
	 * sb wants to have this information
	 * @param value the value of genre
	 */
	void set_genre (string value );
		
	
	/**
	 * Get the value of date
	 * publishdate of the track
	 * @return the value of date
	 */
	string get_date ( );
		
	
	/**
	 * Set the value of date
	 * publishdate of the track
	 * @param value the value of date
	 */
	void set_date (string value );
		
	
	/**
	 * Get the value of comment
	 * I like the idea sb can put a not to a track thats why this attribute is there.
	 * @return the value of comment
	 */
	string get_comment ( );
		
	
	/**
	 * Set the value of comment
	 * I like the idea sb can put a not to a track thats why this attribute is there.
	 * @param value the value of comment
	 */
	void set_comment (string value );
		


	
	/**
	 * Private stuff
	 */
 private:
	/**
	 * Fields
	 */
	/**
	 * number of the track on original album
	 */
	int number;
	/**
	 * Title of track
	 */
	string title;
	/**
	 * Singer/Composer of this track
	 */
	string artist;
	/**
	 * title of the album this track was published 
	 */
	string albumtitle;
	/**
	 * length of the track
	 */
	int time;
	/**
	 * always incorrect information set in ID3v2 tags of an mp3, its implemented just in
	 * case sb wants to have this information
	 */
	string genre;
	/**
	 * publishdate of the track
	 */
	string date;
	/**
	 * I like the idea sb can put a not to a track thats why this attribute is there.
	 */
	string comment;
	
};
#endif //TRACKINFO_H

